type token =
  | SEMI
  | LPAREN
  | RPAREN
  | LBRACE
  | RBRACE
  | LBRACKET
  | RBRACKET
  | COMMA
  | METHOD
  | PLUS
  | MINUS
  | TIMES
  | DIVIDE
  | ASSIGN
  | EQ
  | NEQ
  | LT
  | LEQ
  | GT
  | GEQ
  | AND
  | OR
  | XOR
  | NAND
  | NOR
  | NOT
  | BSL
  | BSR
  | RETURN
  | IF
  | ELSE
  | FOR
  | WHILE
  | ILITERAL of (int)
  | FLITERAL of (float)
  | SLITERAL of (string)
  | ID of (string)
  | EOF
  | ADDRESS
  | SWAP
  | SOURCE
  | MAP
  | INT
  | DOUBLE
  | PORT
  | STRING
  | ENUM
  | INTERRUPT
  | TYPE
  | VOID
  | TRUE
  | FALSE

val program :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ast.program
